Index: uspace/app/sbi/src/symbol.c
===================================================================
--- uspace/app/sbi/src/symbol.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/symbol.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -42,5 +42,4 @@
 static stree_symbol_t *symbol_find_epoint_rec(stree_program_t *prog,
     stree_ident_t *name, stree_csi_t *csi);
-static stree_symbol_t *csimbr_to_symbol(stree_csimbr_t *csimbr);
 static stree_ident_t *symbol_get_ident(stree_symbol_t *symbol);
 
@@ -132,5 +131,4 @@
     stree_csi_t *scope, stree_ident_t *name)
 {
-	stree_symbol_t *base_csi_sym;
 	stree_csi_t *base_csi;
 	stree_symbol_t *symbol;
@@ -142,12 +140,7 @@
 
 	/* Try inherited members. */
-	if (scope->base_csi_ref != NULL) {
-		base_csi_sym = symbol_xlookup_in_csi(prog,
-		    csi_to_symbol(scope)->outer_csi, scope->base_csi_ref);
-		base_csi = symbol_to_csi(base_csi_sym);
-		assert(base_csi != NULL);
-
+	base_csi = symbol_get_base_class(prog, scope);
+	if (base_csi != NULL)
 		return symbol_search_csi(prog, base_csi, name);
-	}
 
 	/* No match */
@@ -212,4 +205,7 @@
 		modm = list_node_data(node, stree_modm_t *);
 
+		/* Make compiler happy. */
+		mbr_name = NULL;
+
 		switch (modm->mc) {
 		case mc_csi: mbr_name = modm->u.csi->name; break;
@@ -217,5 +213,11 @@
 		}
 
+		/* The Clang static analyzer is just too picky. */
+		assert(mbr_name != NULL);
+
 		if (name->sid == mbr_name->sid) {
+			/* Make compiler happy. */
+			symbol = NULL;
+
 			/* Match */
 			switch (modm->mc) {
@@ -231,4 +233,75 @@
 		node = list_next(&prog->module->members, node);
 	}
+
+	return NULL;
+}
+
+/** Get explicit base class for a CSI.
+ *
+ * Note that if there is no explicit base class (class is derived implicitly
+ * from @c object, then @c NULL is returned.
+ *
+ * @param prog	Program to look in
+ * @param csi	CSI
+ *
+ * @return	Base class (CSI) or @c NULL if no explicit base class.
+ */
+stree_csi_t *symbol_get_base_class(stree_program_t *prog, stree_csi_t *csi)
+{
+	list_node_t *pred_n;
+	stree_texpr_t *pred;
+	stree_symbol_t *pred_sym;
+	stree_csi_t *pred_csi;
+	stree_csi_t *outer_csi;
+
+	outer_csi = csi_to_symbol(csi)->outer_csi;
+
+	pred_n = list_first(&csi->inherit);
+	if (pred_n == NULL)
+		return NULL;
+
+	pred = list_node_data(pred_n, stree_texpr_t *);
+	pred_sym = symbol_xlookup_in_csi(prog, outer_csi, pred);
+	pred_csi = symbol_to_csi(pred_sym);
+	assert(pred_csi != NULL); /* XXX! */
+
+	if (pred_csi->cc == csi_class)
+		return pred_csi;
+
+	return NULL;
+}
+
+/** Get type expression referencing base class for a CSI.
+ *
+ * Note that if there is no explicit base class (class is derived implicitly
+ * from @c object, then @c NULL is returned.
+ *
+ * @param prog	Program to look in
+ * @param csi	CSI
+ *
+ * @return	Type expression or @c NULL if no explicit base class.
+ */
+stree_texpr_t *symbol_get_base_class_ref(stree_program_t *prog,
+    stree_csi_t *csi)
+{
+	list_node_t *pred_n;
+	stree_texpr_t *pred;
+	stree_symbol_t *pred_sym;
+	stree_csi_t *pred_csi;
+	stree_csi_t *outer_csi;
+
+	outer_csi = csi_to_symbol(csi)->outer_csi;
+
+	pred_n = list_first(&csi->inherit);
+	if (pred_n == NULL)
+		return NULL;
+
+	pred = list_node_data(pred_n, stree_texpr_t *);
+	pred_sym = symbol_xlookup_in_csi(prog, outer_csi, pred);
+	pred_csi = symbol_to_csi(pred_sym);
+	assert(pred_csi != NULL); /* XXX! */
+
+	if (pred_csi->cc == csi_class)
+		return pred;
 
 	return NULL;
@@ -286,4 +359,5 @@
 	stree_csimbr_t *csimbr;
 	stree_symbol_t *entry, *etmp;
+	stree_symbol_t *fun_sym;
 
 	entry = NULL;
@@ -305,10 +379,13 @@
 			break;
 		case csimbr_fun:
-			if (csimbr->u.fun->name->sid == name->sid) {
+			fun_sym = fun_to_symbol(csimbr->u.fun);
+
+			if (csimbr->u.fun->name->sid == name->sid &&
+			    stree_symbol_has_attr(fun_sym, sac_static)) {
 				if (entry != NULL) {
 					printf("Error: Duplicate entry point.\n");
 					exit(1);
 				}
-				entry = fun_to_symbol(csimbr->u.fun);
+				entry = fun_sym;
 			}
 		default:
@@ -494,5 +571,5 @@
  * @return		Symbol
  */
-static stree_symbol_t *csimbr_to_symbol(stree_csimbr_t *csimbr)
+stree_symbol_t *csimbr_to_symbol(stree_csimbr_t *csimbr)
 {
 	stree_symbol_t *symbol;
@@ -569,4 +646,7 @@
 	stree_ident_t *ident;
 
+	/* Make compiler happy. */
+	ident = NULL;
+
 	switch (symbol->sc) {
 	case sc_csi: ident = symbol->u.csi->name; break;
Index: uspace/app/sbi/src/symbol.h
===================================================================
--- uspace/app/sbi/src/symbol.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/symbol.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,4 +40,7 @@
 stree_symbol_t *symbol_search_csi_no_base(stree_program_t *prog,
     stree_csi_t *scope, stree_ident_t *name);
+stree_csi_t *symbol_get_base_class(stree_program_t *prog, stree_csi_t *csi);
+stree_texpr_t *symbol_get_base_class_ref(stree_program_t *prog,
+    stree_csi_t *csi);
 stree_symbol_t *symbol_find_epoint(stree_program_t *prog, stree_ident_t *name);
 
@@ -57,4 +60,6 @@
 stree_symbol_t *prop_to_symbol(stree_prop_t *prop);
 
+stree_symbol_t *csimbr_to_symbol(stree_csimbr_t *csimbr);
+
 void symbol_print_fqn(stree_symbol_t *symbol);
 
Index: uspace/app/sbi/src/tdata.c
===================================================================
--- uspace/app/sbi/src/tdata.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/tdata.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -343,6 +343,8 @@
 	/* Plain copy */
 	tnew = tdata_ebase_new();
+	tnew->enum_d = tebase->enum_d;
+
 	*res = tdata_item_new(tic_tebase);
-	(*res)->u.tebase = tebase;
+	(*res)->u.tebase = tnew;
 }
 
@@ -362,6 +364,8 @@
 	/* Plain copy */
 	tnew = tdata_enum_new();
+	tnew->enum_d = tenum->enum_d;
+
 	*res = tdata_item_new(tic_tenum);
-	(*res)->u.tenum = tenum;
+	(*res)->u.tenum = tnew;
 }
 
Index: uspace/app/sbi/src/tdata_t.h
===================================================================
--- uspace/app/sbi/src/tdata_t.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/tdata_t.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -58,6 +58,6 @@
 /** Object type. */
 typedef struct {
-	/** @c true if expression is a static CSI reference */
-	bool_t static_ref;
+	/** @c sn_static if expression is a static CSI reference */
+	statns_t static_ref;
 
 	/** CSI definition */
Index: uspace/app/tasks/tasks.c
===================================================================
--- uspace/app/tasks/tasks.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/tasks/tasks.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -165,8 +165,8 @@
 	for (i = 0; i < count; i++) {
 		if (cpus[i].active) {
-			printf("cpu%u: %" PRIu16 " MHz, busy ticks: "
-			    "%" PRIu64 ", idle ticks: %" PRIu64 "\n",
-			    cpus[i].id, cpus[i].frequency_mhz, cpus[i].busy_ticks,
-			    cpus[i].idle_ticks);
+			printf("cpu%u: %" PRIu16 " MHz, busy cycles: "
+			    "%" PRIu64 ", idle cycles: %" PRIu64 "\n",
+			    cpus[i].id, cpus[i].frequency_mhz, cpus[i].busy_cycles,
+			    cpus[i].idle_cycles);
 		} else {
 			printf("cpu%u: inactive\n", cpus[i].id);
Index: uspace/app/top/screen.c
===================================================================
--- uspace/app/top/screen.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/top/screen.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -126,7 +126,7 @@
 }
 
-static void print_float(fixed_float ffloat, unsigned int precision)
-{
-	printf("%2" PRIu64 ".", ffloat.upper / ffloat.lower);
+static void print_percent(fixed_float ffloat, unsigned int precision)
+{
+	printf("%3" PRIu64 ".", ffloat.upper / ffloat.lower);
 	
 	unsigned int i;
@@ -136,4 +136,20 @@
 		rest = (rest % ffloat.lower) * 10;
 	}
+	
+	printf("%%");
+}
+
+static void print_string(const char *str)
+{
+	ipcarg_t cols;
+	ipcarg_t rows;
+	screen_get_size(&cols, &rows);
+	
+	ipcarg_t c;
+	ipcarg_t r;
+	screen_get_pos(&c, &r);
+	
+	if (c < cols)
+		printf("%.*s", cols - c - 1, str);
 }
 
@@ -206,13 +222,20 @@
 	for (i = 0; i < data->cpus_count; i++) {
 		if (data->cpus[i].active) {
-			printf("cpu%u (%4" PRIu16 " MHz): busy ticks: "
-			    "%" PRIu64 ", idle ticks: %" PRIu64,
+			uint64_t busy;
+			uint64_t idle;
+			char busy_suffix;
+			char idle_suffix;
+			
+			order_suffix(data->cpus[i].busy_cycles, &busy, &busy_suffix);
+			order_suffix(data->cpus[i].idle_cycles, &idle, &idle_suffix);
+			
+			printf("cpu%u (%4" PRIu16 " MHz): busy cycles: "
+			    "%" PRIu64 "%c, idle cycles: %" PRIu64 "%c",
 			    data->cpus[i].id, data->cpus[i].frequency_mhz,
-			    data->cpus[i].busy_ticks, data->cpus[i].idle_ticks);
+			    busy, busy_suffix, idle, idle_suffix);
 			puts(", idle: ");
-			print_float(data->cpus_perc[i].idle, 2);
-			puts("%, busy: ");
-			print_float(data->cpus_perc[i].busy, 2);
-			puts("%");
+			print_percent(data->cpus_perc[i].idle, 2);
+			puts(", busy: ");
+			print_percent(data->cpus_perc[i].busy, 2);
 		} else
 			printf("cpu%u inactive", data->cpus[i].id);
@@ -244,8 +267,9 @@
 }
 
-static inline void print_task_head(void)
+static inline void print_tasks_head(void)
 {
 	screen_style_inverted();
-	printf("      ID  Threads      Mem      %%Mem %%uCycles %%kCycles  Name");
+	printf("[taskid] [threads] [virtual] [%%virt] [%%user]"
+	    " [%%kernel] [name");
 	screen_newline();
 	screen_style_normal();
@@ -264,17 +288,20 @@
 	size_t i;
 	for (i = 0; (i < data->tasks_count) && (row < rows); i++, row++) {
+		stats_task_t *task = data->tasks + data->tasks_map[i];
+		perc_task_t *perc = data->tasks_perc + data->tasks_map[i];
+		
 		uint64_t virtmem;
 		char virtmem_suffix;
-		order_suffix(data->tasks[i].virtmem, &virtmem, &virtmem_suffix);
-		
-		printf("%8" PRIu64 " %8u %8" PRIu64 "%c ", data->tasks[i].task_id,
-		    data->tasks[i].threads, virtmem, virtmem_suffix);
+		order_suffix(task->virtmem, &virtmem, &virtmem_suffix);
+		
+		printf("%-8" PRIu64 " %9u %8" PRIu64 "%c ", task->task_id,
+		    task->threads, virtmem, virtmem_suffix);
+		print_percent(perc->virtmem, 2);
+		puts(" ");
+		print_percent(perc->ucycles, 2);
 		puts("   ");
-		print_float(data->tasks_perc[i].virtmem, 2);
-		puts("%   ");
-		print_float(data->tasks_perc[i].ucycles, 2);
-		puts("%   ");
-		print_float(data->tasks_perc[i].kcycles, 2);
-		printf("%% %s", data->tasks[i].name);
+		print_percent(perc->kcycles, 2);
+		puts(" ");
+		print_string(task->name);
 		
 		screen_newline();
@@ -290,5 +317,6 @@
 {
 	screen_style_inverted();
-	printf("      ID Calls sent Calls recv Answs sent Answs recv  IRQn recv       Forw Name");
+	printf("[taskid] [cls snt] [cls rcv] [ans snt]"
+	    " [ans rcv] [irq rcv] [forward] [name");
 	screen_newline();
 	screen_style_normal();
@@ -307,15 +335,130 @@
 	size_t i;
 	for (i = 0; (i < data->tasks_count) && (row < rows); i++, row++) {
-		printf("%8" PRIu64 " %10" PRIu64 " %10" PRIu64 " %10" PRIu64
-		     " %10" PRIu64 " %10" PRIu64 " %10" PRIu64 " %s",
-		     data->tasks[i].task_id, data->tasks[i].ipc_info.call_sent,
-		     data->tasks[i].ipc_info.call_recieved,
-		     data->tasks[i].ipc_info.answer_sent,
-		     data->tasks[i].ipc_info.answer_recieved,
-		     data->tasks[i].ipc_info.irq_notif_recieved,
-		     data->tasks[i].ipc_info.forwarded, data->tasks[i].name);
-		
-		screen_newline();
-	}
+		uint64_t call_sent;
+		uint64_t call_received;
+		uint64_t answer_sent;
+		uint64_t answer_received;
+		uint64_t irq_notif_received;
+		uint64_t forwarded;
+		
+		char call_sent_suffix;
+		char call_received_suffix;
+		char answer_sent_suffix;
+		char answer_received_suffix;
+		char irq_notif_received_suffix;
+		char forwarded_suffix;
+		
+		order_suffix(data->tasks[i].ipc_info.call_sent, &call_sent,
+		    &call_sent_suffix);
+		order_suffix(data->tasks[i].ipc_info.call_received,
+		    &call_received, &call_received_suffix);
+		order_suffix(data->tasks[i].ipc_info.answer_sent,
+		    &answer_sent, &answer_sent_suffix);
+		order_suffix(data->tasks[i].ipc_info.answer_received,
+		    &answer_received, &answer_received_suffix);
+		order_suffix(data->tasks[i].ipc_info.irq_notif_received,
+		    &irq_notif_received, &irq_notif_received_suffix);
+		order_suffix(data->tasks[i].ipc_info.forwarded, &forwarded,
+		    &forwarded_suffix);
+		
+		printf("%-8" PRIu64 " %8" PRIu64 "%c %8" PRIu64 "%c"
+		     " %8" PRIu64 "%c %8" PRIu64 "%c %8" PRIu64 "%c"
+		     " %8" PRIu64 "%c ", data->tasks[i].task_id,
+		     call_sent, call_sent_suffix,
+		     call_received, call_received_suffix,
+		     answer_sent, answer_sent_suffix,
+		     answer_received, answer_received_suffix,
+		     irq_notif_received, irq_notif_received_suffix,
+		     forwarded, forwarded_suffix);
+		print_string(data->tasks[i].name);
+		
+		screen_newline();
+	}
+	
+	while (row < rows) {
+		screen_newline();
+		row++;
+	}
+}
+
+static inline void print_excs_head(void)
+{
+	screen_style_inverted();
+	printf("[exc   ] [count   ] [%%count] [cycles  ] [%%cycles] [description");
+	screen_newline();
+	screen_style_normal();
+}
+
+static inline void print_excs(data_t *data)
+{
+	ipcarg_t cols;
+	ipcarg_t rows;
+	screen_get_size(&cols, &rows);
+	
+	ipcarg_t col;
+	ipcarg_t row;
+	screen_get_pos(&col, &row);
+	
+	size_t i;
+	for (i = 0; (i < data->exceptions_count) && (row < rows); i++) {
+		/* Filter-out cold exceptions if not instructed otherwise */
+		if ((!excs_all) && (!data->exceptions[i].hot))
+			continue;
+		
+		uint64_t count;
+		uint64_t cycles;
+		
+		char count_suffix;
+		char cycles_suffix;
+		
+		order_suffix(data->exceptions[i].count, &count, &count_suffix);
+		order_suffix(data->exceptions[i].cycles, &cycles, &cycles_suffix);
+		
+		printf("%-8u %9" PRIu64 "%c  ",
+		     data->exceptions[i].id, count, count_suffix);
+		print_percent(data->exceptions_perc[i].count, 2);
+		printf(" %9" PRIu64 "%c   ", cycles, cycles_suffix);
+		print_percent(data->exceptions_perc[i].cycles, 2);
+		puts(" ");
+		print_string(data->exceptions[i].desc);
+		
+		screen_newline();
+		row++;
+	}
+	
+	while (row < rows) {
+		screen_newline();
+		row++;
+	}
+}
+
+static void print_help(void)
+{
+	ipcarg_t cols;
+	ipcarg_t rows;
+	screen_get_size(&cols, &rows);
+	
+	ipcarg_t col;
+	ipcarg_t row;
+	screen_get_pos(&col, &row);
+	
+	screen_newline();
+	
+	printf("Operation modes:");
+	screen_newline();
+	
+	printf(" t .. tasks statistics");
+	screen_newline();
+	
+	printf(" i .. IPC statistics");
+	screen_newline();
+	
+	printf(" e .. exceptions statistics");
+	screen_newline();
+	
+	printf("      a .. toggle display of all/hot exceptions");
+	screen_newline();
+	
+	row += 6;
 	
 	while (row < rows) {
@@ -338,10 +481,20 @@
 	screen_newline();
 	
-	if (operation_type == OP_IPC) {
+	switch (op_mode) {
+	case OP_TASKS:
+		print_tasks_head();
+		print_tasks(data);
+		break;
+	case OP_IPC:
 		print_ipc_head();
 		print_ipc(data);
-	} else {
-		print_task_head();
-		print_tasks(data);
+		break;
+	case OP_EXCS:
+		print_excs_head();
+		print_excs(data);
+		break;
+	case OP_HELP:
+		print_tasks_head();
+		print_help();
 	}
 	
Index: uspace/app/top/top.c
===================================================================
--- uspace/app/top/top.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/top/top.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -44,4 +44,5 @@
 #include <arch/barrier.h>
 #include <errno.h>
+#include <sort.h>
 #include "screen.h"
 #include "input.h"
@@ -56,5 +57,7 @@
 #define MINUTE  60
 
-int operation_type;
+op_mode_t op_mode = OP_TASKS;
+sort_mode_t sort_mode = SORT_TASK_CYCLES;
+bool excs_all = false;
 
 static const char *read_data(data_t *target)
@@ -66,6 +69,13 @@
 	target->tasks = NULL;
 	target->tasks_perc = NULL;
+	target->tasks_map = NULL;
 	target->threads = NULL;
+	target->exceptions = NULL;
+	target->exceptions_perc = NULL;
 	target->physmem = NULL;
+	target->ucycles_diff = NULL;
+	target->kcycles_diff = NULL;
+	target->ecycles_diff = NULL;
+	target->ecount_diff = NULL;
 	
 	/* Get current time */
@@ -110,4 +120,9 @@
 		return "Not enough memory for task utilization";
 	
+	target->tasks_map =
+	    (size_t *) calloc(target->tasks_count, sizeof(size_t));
+	if (target->tasks_map == NULL)
+		return "Not enough memory for task map";
+	
 	/* Get threads */
 	target->threads = stats_get_threads(&(target->threads_count));
@@ -115,8 +130,39 @@
 		return "Cannot get threads";
 	
+	/* Get Exceptions */
+	target->exceptions = stats_get_exceptions(&(target->exceptions_count));
+	if (target->exceptions == NULL)
+		return "Cannot get exceptions";
+	
+	target->exceptions_perc =
+	    (perc_exc_t *) calloc(target->exceptions_count, sizeof(perc_exc_t));
+	if (target->exceptions_perc == NULL)
+		return "Not enough memory for exception utilization";
+	
 	/* Get physical memory */
 	target->physmem = stats_get_physmem();
 	if (target->physmem == NULL)
 		return "Cannot get physical memory";
+	
+	target->ucycles_diff = calloc(target->tasks_count,
+	    sizeof(uint64_t));
+	if (target->ucycles_diff == NULL)
+		return "Not enough memory for user utilization";
+	
+	/* Allocate memory for computed values */
+	target->kcycles_diff = calloc(target->tasks_count,
+	    sizeof(uint64_t));
+	if (target->kcycles_diff == NULL)
+		return "Not enough memory for kernel utilization";
+	
+	target->ecycles_diff = calloc(target->exceptions_count,
+	    sizeof(uint64_t));
+	if (target->ecycles_diff == NULL)
+		return "Not enough memory for exception cycles utilization";
+	
+	target->ecount_diff = calloc(target->exceptions_count,
+	    sizeof(uint64_t));
+	if (target->ecount_diff == NULL)
+		return "Not enough memory for exception count utilization";
 	
 	return NULL;
@@ -129,19 +175,7 @@
  *
  */
-static const char *compute_percentages(data_t *old_data, data_t *new_data)
-{
-	/* Allocate memory */
-	
-	uint64_t *ucycles_diff = calloc(new_data->tasks_count, sizeof(uint64_t));
-	if (ucycles_diff == NULL)
-		return "Not enough memory for user utilization";
-	
-	uint64_t *kcycles_diff = calloc(new_data->tasks_count, sizeof(uint64_t));
-	if (kcycles_diff == NULL) {
-		free(ucycles_diff);
-		return "Not enough memory for kernel utilization";
-	}
-	
-	/* For each CPU: Compute total ticks and divide it between
+static void compute_percentages(data_t *old_data, data_t *new_data)
+{
+	/* For each CPU: Compute total cycles and divide it between
 	   user and kernel */
 	
@@ -149,7 +183,7 @@
 	for (i = 0; i < new_data->cpus_count; i++) {
 		uint64_t idle =
-		    new_data->cpus[i].idle_ticks - old_data->cpus[i].idle_ticks;
+		    new_data->cpus[i].idle_cycles - old_data->cpus[i].idle_cycles;
 		uint64_t busy =
-		    new_data->cpus[i].busy_ticks - old_data->cpus[i].busy_ticks;
+		    new_data->cpus[i].busy_cycles - old_data->cpus[i].busy_cycles;
 		uint64_t sum = idle + busy;
 		
@@ -160,7 +194,7 @@
 	/* For all tasks compute sum and differencies of all cycles */
 	
-	uint64_t virtmem_total = 1;  /* Must NOT be zero */
-	uint64_t ucycles_total = 1;  /* Must NOT be zero */
-	uint64_t kcycles_total = 1;  /* Must NOT be zero */
+	uint64_t virtmem_total = 0;
+	uint64_t ucycles_total = 0;
+	uint64_t kcycles_total = 0;
 	
 	for (i = 0; i < new_data->tasks_count; i++) {
@@ -178,20 +212,20 @@
 		if (!found) {
 			/* This is newly borned task, ignore it */
-			ucycles_diff[i] = 0;
-			kcycles_diff[i] = 0;
+			new_data->ucycles_diff[i] = 0;
+			new_data->kcycles_diff[i] = 0;
 			continue;
 		}
 		
-		ucycles_diff[i] =
+		new_data->ucycles_diff[i] =
 		    new_data->tasks[i].ucycles - old_data->tasks[j].ucycles;
-		kcycles_diff[i] =
+		new_data->kcycles_diff[i] =
 		    new_data->tasks[i].kcycles - old_data->tasks[j].kcycles;
 		
 		virtmem_total += new_data->tasks[i].virtmem;
-		ucycles_total += ucycles_diff[i];
-		kcycles_total += kcycles_diff[i];
-	}
-	
-	/* For each task: Compute percential change */
+		ucycles_total += new_data->ucycles_diff[i];
+		kcycles_total += new_data->kcycles_diff[i];
+	}
+	
+	/* For each task compute percential change */
 	
 	for (i = 0; i < new_data->tasks_count; i++) {
@@ -199,15 +233,83 @@
 		    new_data->tasks[i].virtmem * 100, virtmem_total);
 		FRACTION_TO_FLOAT(new_data->tasks_perc[i].ucycles,
-		    ucycles_diff[i] * 100, ucycles_total);
+		    new_data->ucycles_diff[i] * 100, ucycles_total);
 		FRACTION_TO_FLOAT(new_data->tasks_perc[i].kcycles,
-		    kcycles_diff[i] * 100, kcycles_total);
-	}
-	
-	/* Cleanup */
-	
-	free(ucycles_diff);
-	free(kcycles_diff);
-	
-	return NULL;
+		    new_data->kcycles_diff[i] * 100, kcycles_total);
+	}
+	
+	/* For all exceptions compute sum and differencies of cycles */
+	
+	uint64_t ecycles_total = 0;
+	uint64_t ecount_total = 0;
+	
+	for (i = 0; i < new_data->exceptions_count; i++) {
+		/*
+		 * March exception with the previous instance.
+		 * This is quite paranoid since exceptions do not
+		 * usually disappear, but it does not hurt.
+		 */
+		
+		bool found = false;
+		size_t j;
+		for (j = 0; j < old_data->exceptions_count; j++) {
+			if (new_data->exceptions[i].id == old_data->exceptions[j].id) {
+				found = true;
+				break;
+			}
+		}
+		
+		if (!found) {
+			/* This is a new exception, ignore it */
+			new_data->ecycles_diff[i] = 0;
+			new_data->ecount_diff[i] = 0;
+			continue;
+		}
+		
+		new_data->ecycles_diff[i] =
+		    new_data->exceptions[i].cycles - old_data->exceptions[j].cycles;
+		new_data->ecount_diff[i] =
+		    new_data->exceptions[i].count - old_data->exceptions[i].count;
+		
+		ecycles_total += new_data->ecycles_diff[i];
+		ecount_total += new_data->ecount_diff[i];
+	}
+	
+	/* For each exception compute percential change */
+	
+	for (i = 0; i < new_data->exceptions_count; i++) {
+		FRACTION_TO_FLOAT(new_data->exceptions_perc[i].cycles,
+		    new_data->ecycles_diff[i] * 100, ecycles_total);
+		FRACTION_TO_FLOAT(new_data->exceptions_perc[i].count,
+		    new_data->ecount_diff[i] * 100, ecount_total);
+	}
+}
+
+static int cmp_data(void *a, void *b, void *arg)
+{
+	size_t ia = *((size_t *) a);
+	size_t ib = *((size_t *) b);
+	data_t *data = (data_t *) arg;
+	
+	uint64_t acycles = data->ucycles_diff[ia] + data->kcycles_diff[ia];
+	uint64_t bcycles = data->ucycles_diff[ib] + data->kcycles_diff[ib];
+	
+	if (acycles > bcycles)
+		return -1;
+	
+	if (acycles < bcycles)
+		return 1;
+	
+	return 0;
+}
+
+static void sort_data(data_t *data)
+{
+	size_t i;
+	
+	for (i = 0; i < data->tasks_count; i++)
+		data->tasks_map[i] = i;
+	
+	qsort((void *) data->tasks_map, data->tasks_count,
+	    sizeof(size_t), cmp_data, (void *) data);
 }
 
@@ -232,6 +334,24 @@
 		free(target->threads);
 	
+	if (target->exceptions != NULL)
+		free(target->exceptions);
+	
+	if (target->exceptions_perc != NULL)
+		free(target->exceptions_perc);
+	
 	if (target->physmem != NULL)
 		free(target->physmem);
+	
+	if (target->ucycles_diff != NULL)
+		free(target->ucycles_diff);
+	
+	if (target->kcycles_diff != NULL)
+		free(target->kcycles_diff);
+	
+	if (target->ecycles_diff != NULL)
+		free(target->ecycles_diff);
+	
+	if (target->ecount_diff != NULL)
+		free(target->ecount_diff);
 }
 
@@ -249,9 +369,7 @@
 	
 	/* Compute some rubbish to have initialised values */
-	if ((ret = compute_percentages(&data_prev, &data_prev)) != NULL)
-		goto out;
+	compute_percentages(&data_prev, &data_prev);
 	
 	/* And paint screen until death */
-	operation_type = OP_TASKS;
 	while (true) {
 		int c = tgetchar(UPDATE_INTERVAL);
@@ -262,9 +380,6 @@
 			}
 			
-			if ((ret = compute_percentages(&data_prev, &data)) != NULL) {
-				free_data(&data);
-				goto out;
-			}
-			
+			compute_percentages(&data_prev, &data);
+			sort_data(&data);
 			print_data(&data);
 			free_data(&data_prev);
@@ -275,16 +390,33 @@
 		
 		switch (c) {
+			case 't':
+				print_warning("Showing task statistics");
+				op_mode = OP_TASKS;
+				break;
+			case 'i':
+				print_warning("Showing IPC statistics");
+				op_mode = OP_IPC;
+				break;
+			case 'e':
+				print_warning("Showing exception statistics");
+				op_mode = OP_EXCS;
+				break;
+			case 'h':
+				print_warning("Showing help");
+				op_mode = OP_HELP;
+				break;
 			case 'q':
 				goto out;
-			case 'i':
-				print_warning("Showing IPC statistics");
-				operation_type = OP_IPC;
-				break;
-			case 't':
-				print_warning("Showing task statistics");
-				operation_type = OP_TASKS;
-				break;
+			case 'a':
+				if (op_mode == OP_EXCS) {
+					excs_all = !excs_all;
+					if (excs_all)
+						print_warning("Showing all exceptions");
+					else
+						print_warning("Showing only hot exceptions");
+					break;
+				}
 			default:
-				print_warning("Unknown command: %c", c);
+				print_warning("Unknown command \"%c\", use \"h\" for help", c);
 				break;
 		}
Index: uspace/app/top/top.h
===================================================================
--- uspace/app/top/top.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/top/top.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -39,13 +39,29 @@
 #include <time.h>
 
-#define FRACTION_TO_FLOAT(float, a, b) { \
-	(float).upper = (a); \
-	(float).lower = (b); \
-}
+#define FRACTION_TO_FLOAT(float, a, b) \
+	do { \
+		if ((b) != 0) { \
+			(float).upper = (a); \
+			(float).lower = (b); \
+		} else { \
+			(float).upper = 0; \
+			(float).lower = 1; \
+		} \
+	} while (0)
 
-#define OP_TASKS  1
-#define OP_IPC    2
+typedef enum {
+	OP_TASKS,
+	OP_IPC,
+	OP_EXCS,
+	OP_HELP
+} op_mode_t;
 
-extern int operation_type;
+typedef enum {
+	SORT_TASK_CYCLES
+} sort_mode_t;
+
+extern op_mode_t op_mode;
+extern sort_mode_t sort_mode;
+extern bool excs_all;
 
 typedef struct {
@@ -60,8 +76,13 @@
 
 typedef struct {
+	fixed_float virtmem;
 	fixed_float ucycles;
 	fixed_float kcycles;
-	fixed_float virtmem;
 } perc_task_t;
+
+typedef struct {
+	fixed_float cycles;
+	fixed_float count;
+} perc_exc_t;
 
 typedef struct {
@@ -85,9 +106,19 @@
 	stats_task_t *tasks;
 	perc_task_t *tasks_perc;
+	size_t *tasks_map;
 	
 	size_t threads_count;
 	stats_thread_t *threads;
 	
+	size_t exceptions_count;
+	stats_exc_t *exceptions;
+	perc_exc_t *exceptions_perc;
+	
 	stats_physmem_t *physmem;
+	
+	uint64_t *ucycles_diff;
+	uint64_t *kcycles_diff;
+	uint64_t *ecycles_diff;
+	uint64_t *ecount_diff;
 } data_t;
 
Index: uspace/app/trace/syscalls.c
===================================================================
--- uspace/app/trace/syscalls.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/trace/syscalls.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -73,6 +73,5 @@
     [SYS_PHYSMEM_MAP] = { "physmem_map",		4,	V_ERRNO },
     [SYS_IOSPACE_ENABLE] = { "iospace_enable",		1,	V_ERRNO },
-    [SYS_PREEMPT_CONTROL] = { "preempt_control",	1,	V_ERRNO },
-	[SYS_INTERRUPT_ENABLE] = { "interrupt_enable",	2,	V_ERRNO },
+    [SYS_INTERRUPT_ENABLE] = { "interrupt_enable",	2,	V_ERRNO },
 
     [SYS_SYSINFO_GET_TAG] = { "sysinfo_get_tag",		2,	V_INTEGER },
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -87,8 +87,12 @@
 	generic/ipc.c \
 	generic/async.c \
+	generic/async_rel.c \
 	generic/loader.c \
 	generic/getopt.c \
 	generic/adt/list.o \
 	generic/adt/hash_table.o \
+	generic/adt/dynamic_fifo.c \
+	generic/adt/measured_strings.c \
+	generic/adt/char_map.c \
 	generic/time.c \
 	generic/err.c \
@@ -98,6 +102,14 @@
 	generic/vfs/vfs.c \
 	generic/vfs/canonify.c \
+	generic/net/inet.c \
+	generic/net/icmp_common.c \
+	generic/net/icmp_api.c \
+	generic/net/modules.c \
+	generic/net/packet.c \
+	generic/net/socket_client.c \
+	generic/net/socket_parse.c \
 	generic/stacktrace.c \
 	generic/arg_parse.c \
+	generic/sort.c \
 	generic/stats.c
 
Index: uspace/lib/c/arch/abs32le/include/types.h
===================================================================
--- uspace/lib/c/arch/abs32le/include/types.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/abs32le/include/types.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,4 +40,10 @@
 #include <libarch/common.h>
 
+#define SIZE_MIN  UINT32_MIN
+#define SIZE_MAX  UINT32_MAX
+
+#define SSIZE_MIN  INT32_MIN
+#define SSIZE_MAX  INT32_MAX
+
 typedef uint32_t sysarg_t;
 
Index: uspace/lib/c/arch/amd64/include/types.h
===================================================================
--- uspace/lib/c/arch/amd64/include/types.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/amd64/include/types.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,4 +40,10 @@
 #include <libarch/common.h>
 
+#define SIZE_MIN  UINT64_MIN
+#define SIZE_MAX  UINT64_MAX
+
+#define SSIZE_MIN  INT64_MIN
+#define SSIZE_MAX  INT64_MAX
+
 typedef uint64_t sysarg_t;
 
Index: uspace/lib/c/arch/arm32/include/types.h
===================================================================
--- uspace/lib/c/arch/arm32/include/types.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/arm32/include/types.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,4 +41,10 @@
 #include <libarch/common.h>
 
+#define SIZE_MIN  UINT32_MIN
+#define SIZE_MAX  UINT32_MAX
+
+#define SSIZE_MIN  INT32_MIN
+#define SSIZE_MAX  INT32_MAX
+
 typedef uint32_t sysarg_t;
 
Index: uspace/lib/c/arch/ia32/include/types.h
===================================================================
--- uspace/lib/c/arch/ia32/include/types.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/ia32/include/types.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,4 +40,10 @@
 #include <libarch/common.h>
 
+#define SIZE_MIN  UINT32_MIN
+#define SIZE_MAX  UINT32_MAX
+
+#define SSIZE_MIN  INT32_MIN
+#define SSIZE_MAX  INT32_MAX
+
 typedef uint32_t sysarg_t;
 
Index: uspace/lib/c/arch/ia64/include/types.h
===================================================================
--- uspace/lib/c/arch/ia64/include/types.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/ia64/include/types.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,4 +40,10 @@
 #include <libarch/common.h>
 
+#define SIZE_MIN  UINT64_MIN
+#define SIZE_MAX  UINT64_MAX
+
+#define SSIZE_MIN  INT64_MIN
+#define SSIZE_MAX  INT64_MAX
+
 typedef struct {
 	uint64_t lo;
Index: uspace/lib/c/arch/ia64/src/entry.s
===================================================================
--- uspace/lib/c/arch/ia64/src/entry.s	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/ia64/src/entry.s	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -39,5 +39,5 @@
 __entry:
 	alloc loc0 = ar.pfs, 0, 1, 2, 0
-	movl r1 = _gp
+	movl gp = _gp
 
 	# Pass PCB pointer as the first argument to __main
Index: uspace/lib/c/arch/ia64/src/thread_entry.s
===================================================================
--- uspace/lib/c/arch/ia64/src/thread_entry.s	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/ia64/src/thread_entry.s	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -37,5 +37,5 @@
 	alloc loc0 = ar.pfs, 0, 1, 1, 0
 
-	movl r1 = _gp
+	movl gp = _gp
 	
 	#
Index: uspace/lib/c/arch/mips32/include/types.h
===================================================================
--- uspace/lib/c/arch/mips32/include/types.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/c/arch/mips32/include/types.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,4 +41,10 @@
 #include <libarch/common.h>
 
+#define SIZE_MIN  UINT32_MIN
+#define SIZE_MAX  UINT32_MAX
+
+#define SSIZE_MIN  INT32_MIN
+#define SSIZE_MAX  INT32_MAX
+
 typedef uint32_t sysarg_t;
 
